udelaronline/Controllers/CursoController.cs
using System;
using System.Collections.Generic;
using bl;
using dal;
using Microsoft.AspNetCore.Mvc;
using udelaronline.Models;

namespace udelaronline.Controllers
{
    public class CursoController : Controller
    {
        private CursoManager _cursoManager;
        public CursoController()
        {
            _cursoManager = new CursoManager();
        }
        public IActionResult Index()
        {
            var cursos = _cursoManager.lists();
            return View(cursos);
        }

        public IActionResult Add()
        {
            var curso = new CursoViewModel();
            return View(curso);    //si quiero que vaya a una vista que no se llame igual que la accion le pongo View("Add2",curso); 
        }

        [HttpPost]
        public IActionResult Add(CursoViewModel model)
        {
            if (ModelState.IsValid)
            {
                var curso = new Curso()
                {
                    Nombre = model.Nombre,
                    Descripcion = model.Descripcion,
                    FechaDeCreacion = DateTime.Now,
                    //Asistentes = new List<Asistente>(),
                    //EstudiantesMatriculados = new List<UsuarioCurso>()
                };
                _cursoManager.add(curso);
                return RedirectToAction("Index");
            }
            return View(model);
        }

        public IActionResult Delete(int id)
        {
            _cursoManager.delete(id);
            return RedirectToAction("Index");
        }

        public IActionResult Edit(int id)
        {
            var curso = _cursoManager.get(id);
            var model = new CursoViewModel()
            {
                Id = curso.Id,
                Nombre = curso.Nombre,
                Descripcion = curso.Descripcion
            };
            return View(model);
        }

        [HttpPost]
        public IActionResult Edit(CursoViewModel model)
        {
            if (ModelState.IsValid)
            {
                var curso = new Curso()
                {
                    Id = model.Id,
                    Nombre = model.Nombre,
                    Descripcion = model.Descripcion
                    //Asistentes = model.Asistentes,
                    //EstudiantesMatriculados = model.EstudiantesMatriculados
                };
                _cursoManager.edit(curso);
                return RedirectToAction("Index");
            }
            return View(model);
        }
    }
}

udelaronline/Controllers/FacultadController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using bl;
using dal;
using Microsoft.AspNetCore.Mvc;
using udelaronline.Models;

namespace udelaronline.Controllers
{
    public class FacultadController : Controller
    {
        private FacultadManager _facultadManager;
        private CursoManager _cursoManager;
        private UsuarioManager _usuarioManager;

        public FacultadController()
        {
            _facultadManager = new FacultadManager();
            _cursoManager = new CursoManager();
            _usuarioManager = new UsuarioManager();
        }
        public IActionResult Index()
        {
            var facultades = _facultadManager.lists();
            return View(facultades);
        }
        public IActionResult Add()
        {
            var facu = new FacultadViewModel();
            return View(facu);    //si quiero que vaya a una vista que no se llame igual que la accion le pongo View("Add2",facu); 
        }

        [HttpPost]
        public IActionResult Add(FacultadViewModel model)
        {
            if (ModelState.IsValid)
            {
                var facu = new Facultad()
                {
                    Nombre = model.Nombre,
                    Abreviatura = model.Abreviatura,
                    FechaDeCreacion = DateTime.Now,
                    Cursos = new List<Curso>(),
                    //Administradores = new List<Usuario>(),
                    //EstudiantesInscriptos = new List<Usuario>()
                };
                _facultadManager.add(facu);
                return RedirectToAction("Index");   //return RedirectToAction("Index", "Home", new { mensaje = "Password incorrecta" });
            }
            return View(model);
        }

        public IActionResult Delete(int id)
        {
            _facultadManager.delete(id);
            return RedirectToAction("Index");
        }

        public IActionResult Edit(int id)
        {
            var facu = _facultadManager.get(id);
            var model = new FacultadViewModel()
            {
                Id = facu.Id,
                Nombre = facu.Nombre,
                Abreviatura = facu.Abreviatura
            };
            return View(model);
        }

        [HttpPost]
        public IActionResult Edit(FacultadViewModel model)
        {
            if (ModelState.IsValid)
            {
                var facu = new Facultad()
                {
                    Id = model.Id,
                    Nombre = model.Nombre,
                    Abreviatura = model.Abreviatura
                };
                _facultadManager.edit(facu);
                return RedirectToAction("Index");
            }
            return View(model);
        }

        public IActionResult CursosEnFac(int id)
        {
            var facu = _facultadManager.get(id);
            var model = new FacultadViewModel()
            {
                Id = facu.Id,
                Nombre = facu.Nombre,
                Abreviatura = facu.Abreviatura,
                Cursos = _cursoManager.getCursosEnFacultad(facu.Id)
            };
            return View(model);
        }

        public IActionResult SelecionCurso(int id)
        {
            //Console.WriteLine("SelecionCurso idFacu  " + id);
            var cursos = _cursoManager.lists();
            var model = new CursosFacultadViewModel()
            {
                IdFacultad = id,
                Cursos = cursos
            };
            return View(model);
        }

        [HttpPost]
        public IActionResult SelecionCurso(CursosFacultadViewModel model)
        {
            bool existeCurso = false;
            var totalCursos = _cursoManager.lists();
            foreach (Curso auxC in totalCursos)
            {
                if (auxC.Id == model.IdCursoAIngresar)
                {
                    existeCurso = true;
                }
            }
            Console.WriteLine(existeCurso);
            if (ModelState.IsValid && existeCurso)
            {
                _facultadManager.agregarCurso(model.IdFacultad, model.IdCursoAIngresar);
                return RedirectToAction("Index");
            }
            return View(model);
        }

        public IActionResult UsuariosEnFac(int id)
        {
            var facu = _facultadManager.get(id);
            var model = new FacultadViewModel()
            {
                Id = facu.Id,
                Nombre = facu.Nombre,
                Abreviatura = facu.Abreviatura,
                EstudiantesInscriptos = _usuarioManager.getUsuariosEnFacultad(facu.Id)
            };
            return View(model);
        }

        public IActionResult SelecionUsuario(int id)
        {
            //Console.WriteLine("SelecionCurso idFacu  " + id);
            var usuarios = _usuarioManager.lists();
            var model = new EstudiantesFacultadViewModel()
            {
                IdFacultad = id,
                Estudiantes = usuarios
            };
            return View(model);
        }

        
        [HttpPost]
        public IActionResult SelecionUsuario(EstudiantesFacultadViewModel model)
        {
            bool existeUsuario = false;
            var totalUsuarios = _usuarioManager.lists();
            foreach (Usuario auxU in totalUsuarios)
            {
                if (auxU.Id == model.IdUsuarioAIngresar)
                {
                    existeUsuario = true;
                }
            }
            //Console.WriteLine(existeUsuario);
            if (ModelState.IsValid && existeUsuario)
            {
                _facultadManager.agregarEstudiante(model.IdFacultad, model.IdUsuarioAIngresar);
                return RedirectToAction("Index");
            }
            return View(model);
        }

    }
}

udelaronline/Controllers/ReportesController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using bl;
using dal;
using Microsoft.AspNetCore.Mvc;
using udelaronline.Models;

namespace udelaronline.Controllers
{
    public class ReportesController : Controller
    {
        private FacultadManager _facultadManager;
        private UsuarioManager _usuarioManager;

        public ReportesController()
        {
            _facultadManager = new FacultadManager();
            _usuarioManager = new UsuarioManager();
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult ReporteDeUsuariosPorFacultad()
        {
            var model = new List<EstudiantesFacultadViewModel>();

            var facultades = _facultadManager.lists();
            foreach (var facu in facultades)
            {
                var usuarios = _usuarioManager.getUsuariosEnFacultad(facu.Id);
                var estEnFacu = new EstudiantesFacultadViewModel()
                {
                    IdFacultad = facu.Id,
                    FacultadNombre = facu.Nombre,
                    Estudiantes = usuarios
                };
                model.Add(estEnFacu);
            }

            return View(model);
        }

        public IActionResult NoImplementado()
        {
            return View();
        }
        /*

        public IActionResult UsuariosEnFac(int id)
        {
            var facu = _facultadManager.get(id);
            var model = new FacultadViewModel()
            {
                Id = facu.Id,
                Nombre = facu.Nombre,
                Abreviatura = facu.Abreviatura,
                EstudiantesInscriptos = _usuarioManager.getUsuariosEnFacultad(facu.Id)
            };
            return View(model);
        }

        public IActionResult SelecionUsuario(int id)
        {
            //Console.WriteLine("SelecionCurso idFacu  " + id);
            var usuarios = _usuarioManager.lists();
            var model = new EstudiantesFacultadViewModel()
            {
                IdFacultad = id,
                Estudiantes = usuarios
            };
            return View(model);
        }


        [HttpPost]
        public IActionResult SelecionUsuario(EstudiantesFacultadViewModel model)
        {
            bool existeUsuario = false;
            var totalUsuarios = _usuarioManager.lists();
            foreach (Usuario auxU in totalUsuarios)
            {
                if (auxU.Id == model.IdUsuarioAIngresar)
                {
                    existeUsuario = true;
                }
            }
            //Console.WriteLine(existeUsuario);
            if (ModelState.IsValid && existeUsuario)
            {
                _facultadManager.agregarEstudiante(model.IdFacultad, model.IdUsuarioAIngresar);
                return RedirectToAction("Index");
            }
            return View(model);
        }
        */
    }
}

udelaronline/Controllers/UsuarioController.cs
using System;
using bl;
using dal;
using Microsoft.AspNetCore.Mvc;
using udelaronline.Models;

namespace udelaronline.Controllers
{
    public class UsuarioController : Controller
    {
        private UsuarioManager _usuarioManager;
        public UsuarioController()
        {
            _usuarioManager = new UsuarioManager();
        }
        public IActionResult Index()
        {
            var usuarios = _usuarioManager.lists();
            return View(usuarios);
        }
        public IActionResult Add()
        {
            var usuario = new UsuarioViewModel();
            return View(usuario);    //si quiero que vaya a una vista que no se llame igual que la accion le pongo View("Add2",usuario); 
        }

        [HttpPost]
        public IActionResult Add(UsuarioViewModel model)
        {
            if (ModelState.IsValid)
            {
                var usuario = new Usuario()
                {
                    Nombre = model.Nombre,
                    Apellido = model.Apellido,
                    FechaDeAlta = DateTime.Now,
                    Correo = model.Correo,
                    Telefono = model.Telefono
                };
                _usuarioManager.add(usuario);
                return RedirectToAction("Index");
            }
            return View(model);
        }

        public IActionResult Delete(int id)
        {
            _usuarioManager.delete(id);
            return RedirectToAction("Index");
        }

        public IActionResult Edit(int id)
        {
            var usuario = _usuarioManager.get(id);
            var model = new UsuarioViewModel()
            {
                Id = usuario.Id,
                Nombre = usuario.Nombre,
                Apellido = usuario.Apellido,
                Correo = usuario.Correo,
                Telefono = usuario.Telefono
            };
            return View(model);
        }

        [HttpPost]
        public IActionResult Edit(UsuarioViewModel model)
        {
            if (ModelState.IsValid)
            {
                var usuario = new Usuario()
                {
                    Id = model.Id,
                    Nombre = model.Nombre,
                    Apellido = model.Apellido,
                    Correo = model.Correo,
                    //Comments = new List<Comment>()
                };
                _usuarioManager.edit(usuario);
                return RedirectToAction("Index");
            }
            return View(model);
        }
    }
}

udelaronline/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - udelaronline</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">udelaronline</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Usuario" asp-action="Index">Usuarios</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Facultad" asp-action="Index">Facultades</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Curso" asp-action="Index">Cursos</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Reportes" asp-action="Index">Reportes</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2020 - udelaronline - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>

udelaronline/Views/Shared/_LayoutLogin.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - udelaronline</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2020 - udelaronline - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>